unit Koerper;

interface

type  CKoerper = class(TObject)
  private
  protected
     m_name:string;
     m_volumen:double;
    { Protected-Deklarationen }
  public
    { Public-Deklarationen }
    constructor create(name:string; volumen:double);  overload;
    constructor create(krp:CKoerper);                overload;
    destructor  Destroy;                               override;
    procedure   setData(krp:CKoerper);
    function    getVolumen():double;
    procedure   setVolumen(volumen:double);
    function    getName():string;
    procedure   setName(name:string);
    function    toString():string;  virtual;
    function    add(krp:CKoerper):CKoerper;
  published
end;   // CKoerper

type  CKugel = class(CKoerper)
  private
  protected
     m_r:double;
    { Protected-Deklarationen }
  public
    { Public-Deklarationen }
    constructor create(name:string; r:double);
    function    getR():double;
    procedure   setR(r:double);
    function    toString():string;  override;
  published
end;   // CKugel


type  CQuader = class(CKoerper)
  private
  protected
     m_a:double;
     m_b:double;
     m_c:double;
    { Protected-Deklarationen }
  public
    { Public-Deklarationen }
    constructor create(name:string; a,b,c:double);
    function    getA():double;
    procedure   setA(a:double);
    function    getB():double;
    procedure   setB(b:double);
    function    getC():double;
    procedure   setC(c:double);
    function    toString():string;  override;
  published
end;   // CQuader


type  CWuerfel = class(CKoerper)
  private
  protected
     m_a:double;
    { Protected-Deklarationen }
  public
    { Public-Deklarationen }
    constructor create(name:string; a:double);
    function    getA():double;
    procedure   setA(a:double);
    function    toString():string;  override;
  published
end;   // CWuerfel


implementation

uses CBasis;

constructor CKoerper.create(name:string; volumen:double);
begin
  inherited create;
  self.m_name:=name;
  self.m_volumen:=volumen;
end;

constructor CKoerper.create(krp:CKoerper);
begin
  inherited create;
  self.m_name:=krp.m_name;
  self.m_volumen:=krp.m_volumen;
end;

procedure CKoerper.setData(krp:CKoerper);
begin
  self.m_name:=krp.m_name;
  self.m_volumen:=krp.m_volumen;
end;

destructor CKoerper.Destroy;
begin
  inherited Destroy;
end;

function    CKoerper.getVolumen():double;
begin
  result := m_volumen;
end;

procedure   CKoerper.setVolumen(volumen:double);
begin
  if ( volumen > 0)  then
  begin
    self.m_volumen:=volumen;
  end
  else
  begin
    ErrorBox('Setzen eines Volumen','Fehler in Modul CKoerper,' + NL+
                  'Methode setVolumen, Volumen: '+DoubleStr2(volumen) );

  end
end;


function    CKoerper.getName():string;
begin
  result := m_name;
end;

procedure   CKoerper.setName(name:string);
begin
  self.m_name:=name;
end;

function CKoerper.toString():string;
begin
  result :='Name : ' + m_name+  '    Volumen: ' + DoubleStr2(m_volumen);
end;



function CKoerper.add(krp:CKoerper):CKoerper;
var krp_temp:CKoerper;
begin
  krp_temp:=CKoerper.create(krp);
  krp_temp.m_volumen := krp_temp.m_volumen + krp.m_volumen;
  result := krp_temp;
end;

// ----------------------------------------------------------------------------------


constructor CKugel.create(name:string; r:double);
begin
  inherited create(name,0.0);  // hier wird der obere Konstruktor aufgerufen
  self.m_r:=r;
  m_volumen := 4.0/3.0* m_r * m_r * m_r * PI;
end;


function CKugel.getR():double;
begin
  result := m_r;
end;

procedure CKugel.setR(r:double);
begin
  self.m_r := r;
end;

function CKugel.toString():string;
begin
  result :='Kugel:  Name : ' + m_name+  '    Volumen: ' + DoubleStr2(m_volumen)+  '    Radius: ' + DoubleStr2(m_r);;
end;

// ----------------------------------------------------------------------------------

constructor CQuader.create(name:string; a,b,c:double);
begin
  inherited create(name,0.0);  // hier wird der obere Konstruktor aufgerufen
  self.m_a:=a;
  self.m_b:=b;
  self.m_c:=c;
  m_volumen := m_a*m_b*m_c;
end;


function CQuader.getA():double;
begin
  result := m_a;
end;
procedure CQuader.setA(a:double);
begin
  self.m_a := a;
end;


function CQuader.getB():double;
begin
  result := m_b;
end;
procedure CQuader.setB(b:double);
begin
  self.m_b := b;
end;


function CQuader.getC():double;
begin
  result := m_c;
end;

procedure CQuader.setC(c:double);
begin
  self.m_c := c;
end;


function CQuader.toString():string;
begin
  result :='Quader:  Name : ' + m_name+  '    Volumen: ' + DoubleStr2(m_volumen)+
     '    A: ' + DoubleStr2(m_a)+
     '    B: ' + DoubleStr2(m_b)+
     '    C: ' + DoubleStr2(m_c)
     ;
end;

// ----------------------------------------------------------------------------------

constructor CWuerfel.create(name:string; a:double);
begin
  inherited create(name,0.0);  // hier wird der obere Konstruktor aufgerufen
  self.m_a:=a;
  m_volumen := m_a*m_a*m_a;
end;


function CWuerfel.getA():double;
begin
  result := m_a;
end;
procedure CWuerfel.setA(a:double);
begin
  self.m_a := a;
end;


function CWuerfel.toString():string;
begin
  result :='Wrfel:  Name : ' + m_name+  '    Volumen: ' + DoubleStr2(m_volumen)+
     '    A: ' + DoubleStr2(m_a)
     ;
end;

end.
